package jp.programmingmat.www.gbtkgl10;

/**
	移動・回転情報クラス。
	描画位置の設定やオブジェクトの配置に使用します。
*/
public class GbtkGL10Transform {

	private GbtkGL10Vector3f mTranslate;
	private GbtkGL10Vector3f mRotate;

	public GbtkGL10Transform() {

		mTranslate = new GbtkGL10Vector3f();
		mRotate = new GbtkGL10Vector3f();
		
	}

	public GbtkGL10Transform(GbtkGL10Transform src) {

		if (src == null) {

			mTranslate = new GbtkGL10Vector3f();
			mRotate = new GbtkGL10Vector3f();

		} else {
			
			mTranslate = new GbtkGL10Vector3f(src.getTranslate());
			mRotate = new GbtkGL10Vector3f(src.getRotate());
			
		}
		
	}
	
	public GbtkGL10Transform(GbtkGL10Vector3f translate, GbtkGL10Vector3f rotate) {

		mTranslate = new GbtkGL10Vector3f(translate);
		mRotate = new GbtkGL10Vector3f(rotate);
		
	}

	public GbtkGL10Transform(float tx, float ty, float tz, float rx, float ry, float rz) {

		mTranslate = new GbtkGL10Vector3f(tx, ty, tz);
		mRotate = new GbtkGL10Vector3f(rx, ry, rz);
		
	}

	/**
	 * 位置情報を取得
	 * @return 位置情報を保持するベクトル
	 */
	public GbtkGL10Vector3f getTranslate() {
		return mTranslate;
	}

	public void setTranslate(GbtkGL10Vector3f translate) {
		mTranslate.set(translate);
	}

	public void setTranslate(float x, float y, float z) {
		mTranslate.set(x, y, z);
	}

	public void addTranslate(float dx, float dy, float dz) {
		mTranslate.add(dx, dy, dz);
	}

	public void addTranslate(GbtkGL10Vector3f vec) {
		if (vec == null) {
			return;
		} else {
			mTranslate.add(vec);
		}
	}
	
	public GbtkGL10Vector3f getRotate() {
		return mRotate;
	}

	public void setRotate(GbtkGL10Vector3f rotate) {
		mTranslate.set(rotate);
	}

	public void setRotate(float x, float y, float z) {
		mRotate.set(x, y, z);
	}

	public void addRotate(float dx, float dy, float dz) {
		mRotate.add(dx, dy, dz);
	}

	public void addRotate(GbtkGL10Vector3f vec) {
		if (vec == null) {
			return;
		} else {
			mRotate.add(vec);
		}
	}
	
}