package jp.programmingmat.www.gbtkgl10;

import javax.microedition.khronos.egl.EGLConfig;
import javax.microedition.khronos.opengles.GL10;

import android.content.Context;
import android.opengl.GLSurfaceView;
import android.opengl.GLSurfaceView.Renderer;

/**
 * worldを生成・保持・描画するGLSurfaceViewのサブクラス。
 * デフォルトでは、このViewのOpenGL ESスレッド（onDrawFrame()呼び出し）がworldの処理を駆動します。
*/
public class GbtkGL10View extends GLSurfaceView implements Renderer {

	private float mAspect;
	private GbtkGL10World mWorld;
	
	public GbtkGL10View(Context context, GbtkGL10World world) {

		super(context);

    	mWorld = world;

    	mWorld.init();
    	
		setRenderer(this);
		
	}

	public GbtkGL10World getWorld() {
		return mWorld;
	}
	
    @Override
    public void onSurfaceCreated(GL10 gl, EGLConfig config) {

    	mWorld.setGLInterface(gl);
    	mWorld.loadTexture();
    	
    }

    @Override
    public void onSurfaceChanged(GL10 gl, int width, int height) {

    	gl.glViewport(0, 0, width, height);

    	mAspect = (float)width / (float)height;

    	mWorld.setAspect(mAspect);

    }

    @Override
    public void onDrawFrame(GL10 gl) {

    	mWorld.setGLInterface(gl);
    	
    	mWorld.prepareRender();
    	mWorld.render();
    	
   	}
	
}
