package jp.programmingmat.www.gbtkgl10;

import android.graphics.Bitmap;
import android.graphics.Bitmap.Config;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Paint.Style;

/**
	GbtkGL10ライブラリテスト用world
*/
public class TestWorld extends GbtkGL10World {

	GbtkGL10Mesh mTestBox;
	
	public TestWorld(GbtkGL10Activity activity) {
		super(activity);
	}

	@Override
	public void init() {

		// 0番のテクスチャを貼り付ける立方体を作成
		mTestBox = new GbtkGL10Mesh(GbtkGL10Geometry.createBoxGeometry(2, 2, 2), new GbtkGL10Material(1, 1, 1, 1, 0));

		mTestBox.setPosition(0, 0, -4);
		
		addDrawObject(mTestBox);

		// 背景色を設定
		setClearRGBA(0.25f, 0, 0.5f, 1);
		
	}

	@Override
	public void loadTexture() {

		// 256*256ピクセルのビットマップを作成
		Bitmap bmp = Bitmap.createBitmap(256, 256, Config.ARGB_8888);
		
		Canvas cv = new Canvas(bmp);
		cv.drawARGB(255, 255, 192, 192);

		Paint pt = new Paint();
		pt.setStyle(Style.FILL);

		// 適当に描画
		for (int i = 0;i < 128;i++) {

			pt.setARGB(255, 255 - i * 2, i * 2, i * 2);
			
			cv.drawRect(i, i, 255 - i, 255 - i, pt);

		}

		// 0番のテクスチャとして登録
		setTexture(bmp, 0);

		bmp.recycle();

	}
	
	@Override
	public void process() {

		// 立方体を回転
		mTestBox.addRotate(4, 2, 1);

		// カメラを遠ざける
		if (getCamera().getPosition().get(2) < 6) {
			getCamera().getPosition().add(0, 0, 0.05f);
		}
		
	}
	
}