package jp.programmingmat.www.gbtkgl10;

/*
 * GbtkGL10ライブラリ GbtkGL10Activityクラス
 *
 * 2013/04/15 創作プログラミングの街
 */
import android.app.Activity;
import android.os.Bundle;
import android.view.View;

/**
 * AndroidアプリのActivityを定義するActivityクラス。
 * サブクラスでcreateView()をオーバーライドし、アプリのworldを作成してください。onPause()/onResume()をオーバーライドする場合は、GLSurfaceViewのポーズ処理を行なうためsuper()呼び出しを忘れずに。
 */
public class GbtkGL10Activity extends Activity {

	private GbtkGL10View mView;
	private GbtkGL10World mWorld;
		
    @Override
    public void onCreate(Bundle savedInstanceState) {

    	super.onCreate(savedInstanceState);

    	mWorld = createWorld();
    	
    	mView = createView(mWorld);

    	setContentView(createContentView());
    	
    }

    /**
     * アプリに配置するコンポーネントを定義します。
     * オーバーライドすることで、view以外のコンポーネントを追加できます。
     * @return setContentViewに渡すviewオブジェクト
     */
    protected View createContentView() {
    	return getView();
    }
    
    /**
     * アプリで使用するviewを作成し、返します。
     * 独自のviewを作成する場合は、オーバーライドします。
     * @return world
     */
    protected GbtkGL10View createView(GbtkGL10World world) {
    	return new GbtkGL10View(this, world);
    }
    
    /**
     * アプリで使用するworldを作成し、返します。
     * 独自のworldを作成して返すようオーバーライドしてください。
     * @return world
     */
    protected GbtkGL10World createWorld() {
    	return new GbtkGL10World(this);
    }
    
    public GbtkGL10View getView() {
    	return mView;
    }

    public GbtkGL10World getWorld() {
    	return mWorld;
    }

    @Override
    public void onPause() {

    	mView.onPause();

    	super.onPause();
    	
    }
    
    @Override
    public void onResume() {

    	super.onResume();
    	
    	mView.onResume();
    	
    }
	
}